(* CVT2TXT.PAS -- translate GEOS text files
** Copyright (C) 1995,1996  Jochen Metzinger
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

PROGRAM cvt2txt;

USES global, fonts, cvt, texts;

VAR chain: ShortInt;

PROCEDURE usage;
BEGIN
 WriteLn('CVT2TXT V', Version, Country, '  Convert GEOS text files');
 WriteLn('Copyright (c) 1995,1996 Jochen Metzinger ');
 WriteLn;
 WriteLn(short_usage);
 WriteLn;
 WriteLn('  input     GEOS text file');
 WriteLn('  output    text output file');
 WriteLn('  /F        force output to a file');
 WriteLn('  /V        verbose output');
 HALT(1);
END; (* usage *)

PROCEDURE Init;
 VAR in_name, out_name: STRING;
  i, j: INTEGER; par: STRING;
  force: BOOLEAN;
BEGIN
 short_usage := 'CVT2TXT [/?] input [output] [options]';
 verbose := FALSE;
 in_name := ''; out_name := '';
 force := FALSE;
 IF ParamCount = 0 THEN usage;
 FOR i := 1 TO ParamCount DO BEGIN
  par := ParamStr(i);
  IF Copy(par,1,1) = '/' THEN
   BEGIN
    IF Length(par) = 1 THEN FATAL('unknown option '+par);
    FOR j := 2 TO Length(par) DO
     CASE UpCase(par[j]) OF
      '?': usage;
      'F': force := TRUE;
      'V': verbose := TRUE;
      ELSE FATAL('unknown option '+par);
     END; (* case *)
   END
  ELSE IF in_name = '' THEN
   in_name := par
  ELSE IF out_name = '' THEN
   out_name := par
  ELSE
   FATAL('too many arguments');
 END; (* for *)
 IF in_name = '' THEN usage;
 cvt_open(in_name);
 short_usage := '';
 IF force AND (out_name = '') THEN
  out_name := GetFileName(in_name) + '.TXT';
 {$I-}
 Assign(out_file, out_name);
 ReWrite(out_file);
 {$I+}
 IF IOResult <> 0 THEN
  FATAL('unable to create file');
 IF out_name <> '' THEN
  WriteLn(AddExt(in_name,'.'+CVT_EXT),' -> ',out_name);
 OpenTxt;
END; (* init *)

BEGIN
 Init;
 FOR chain := 0 TO max_chain DO
  OutputChain(chain);
 CloseTxt;
 cvt_close;
 Close(out_file);
END. (* cvt2txt *)
