(* CVT_REC.PAS -- extract chains from a GEOS files
** Copyright (C) 1995,1996  Jochen Metzinger
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

PROGRAM cvt_rec;

USES global, cvt;

CONST
 BufSize = 32*1024;

VAR chain: INTEGER;
 code: INTEGER;
 result: WORD;
 i: LongInt;
 buf: ARRAY [1..BufSize] OF CHAR;
 dir: DirRec ABSOLUTE buf;
 info: InfoRec ABSOLUTE buf;

PROCEDURE usage;
BEGIN
 WriteLn('CVT_REC V', Version, '  Output a chain of a GEOS file');
 WriteLn('Copyright (c) 1995,1996 Jochen Metzinger ');
 WriteLn;
 WriteLn(short_usage);
 WriteLn;
 WriteLn('  filename    GEOS file');
 WriteLn('  number      chain number (0-126)');
 HALT(1);
END; (* usage *)

BEGIN (* cvt_rec *)
 short_usage := 'CVT_REC [/?] filename number';
 IF (ParamStr(1) = '/?') OR (ParamStr(1) = '') THEN usage;
 cvt_open(ParamStr(1));
 Val(ParamStr(2),chain,code);
 IF code <> 0 THEN FATAL('not a number');
 IF chain > 126 THEN
  FATAL('out of range')
 ELSE IF chain >= 0 THEN
  BEGIN (* a normal chain *)
   cvt_chain(chain);
   REPEAT
    cvt_read(buf,SizeOf(buf),result);
    FOR i := 1 TO result DO
     Write(buf[i]);
   UNTIL result = 0;
  END
 ELSE IF chain = -1 THEN
  BEGIN (* info sector *)
   cvt_info(info);
   FOR i := 1 TO SizeOf(info) DO
    Write(buf[i]);
  END
 ELSE IF chain = -2 THEN
  BEGIN (* dir entry *)
   cvt_dir(dir);
   FOR i := 1 TO SizeOf(dir) DO
    Write(buf[i]);
  END
 ELSE IF chain = -3 THEN
  BEGIN (* vlir *)
   cvt_vlir(info);
   FOR i := 1 TO SizeOf(info) DO
    Write(buf[i]);
  END
 ELSE (* chain < -3 *)
  FATAL('out of range');
 cvt_close;
END. (* cvt_rec *)
