(* CVT_SIZE.PAS -- show sizes of used chains in a GEOS files
** Copyright (C) 1995,1996  Jochen Metzinger
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

PROGRAM cvt_size;

USES global, cvt;

VAR i: BYTE;
 len: LongInt;

PROCEDURE usage;
BEGIN
 WriteLn('CVT_SIZE V', Version, '   Show the size of chains of a GEOS file');
 WriteLn('Copyright (c) 1995,1996 Jochen Metzinger ');
 WriteLn;
 WriteLn(short_usage);
 WriteLn;
 WriteLn('  filename    GEOS file');
 HALT(1);
END; (* usage *)

BEGIN (* cvt_size *)
 short_usage := 'CVT_SIZE [/?] filename';
 IF (ParamStr(1) = '/?') OR (ParamStr(1) = '') THEN usage;
 cvt_open(ParamStr(1));
 WriteLn(ParamStr(1),':');
 FOR i := 0 TO 130 DO BEGIN
  len := cvt.cvt_size(i);
  IF len >= 0 THEN
   WriteLn(i:3,': ',len);
 END; (* for *)
 cvt_close;
END. (* cvt_size *)
