(* DIR.PAS -- access the directory
** Copyright (C) 1995,1996  Jochen Metzinger
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

UNIT dir;

INTERFACE

USES global, fonts, D64;

PROCEDURE OpenDir;
(* Open/Reset directory reading *)
PROCEDURE CloseDir;
(* close reading *)

FUNCTION EndOfDir: BOOLEAN;
(* no more dir entries? *)
FUNCTION FirstDirPage: BOOLEAN;
(* First dir entry in a block? *)
PROCEDURE ReadDir(VAR dr: DirRec);
(* get next dir entry *)

FUNCTION FileName(VAR dr: DirRec): STRING;
(* extract file name from dr *)
 
IMPLEMENTATION

USES errors;

VAR
 borderp: BOOLEAN;
 data_ptr: INTEGER;
 data: D64_BLOCK;

PROCEDURE OpenDir;
BEGIN
 data_ptr := 0;
 borderp := TRUE;
 d64_read(BorderTr, BorderSc, data); (* Border Directory *)
 err_stop;
END; (* OpenDir *)

PROCEDURE CloseDir;
BEGIN
END; (* CloseDir *)

FUNCTION FirstDirPage: BOOLEAN;
BEGIN
 FirstDirPage := (data_ptr = 0);
END; (* FirstDirPage *)

FUNCTION EndOfDir: BOOLEAN;
BEGIN
 EndOfDir := (data_ptr < 0);
END; (* EndOfDir *)

PROCEDURE ReadDir(VAR dr: DirRec);
BEGIN
 Move(data[data_ptr+2],dr,SizeOf(dr));
 Inc(data_ptr, 32);
 IF data_ptr > $FF THEN BEGIN
  IF borderp THEN
   BEGIN
    d64_read($12,$01,data);
    borderp := FALSE;
   END
  ELSE
   BEGIN
    IF data[0] = 0 THEN BEGIN
     data_ptr := -1;
     EXIT;
    END; (* if *)
    d64_read(data[0],data[1],data);
   END; (* else *)
  err_stop;
  data_ptr := 0;
 END; (* if *)
END; (* ReadDir *)

FUNCTION FileName(VAR dr: DirRec): STRING;
 VAR s: STRING; i: INTEGER;
BEGIN
 s := dr.name;
 i := Pos(#$A0, s);
 IF i > 0 THEN Delete(s,i,$FF);
 FileName := TransStr(s);
END; (* FileName *)

END. (* dir *)
