(* DUMP.PAS -- dump memory
** Copyright (C) 1995,1996  Jochen Metzinger
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

UNIT DUMP;

INTERFACE

USES global;

PROCEDURE DumpVar(VAR vari; len, offset: WORD);
(* dump memory of a variable *)

PROCEDURE DumpMem(addr: POINTER; len, offset: WORD);
(* dumo memory at addr *)

IMPLEMENTATION

TYPE
 BPTR = ^BYTE;

PROCEDURE DumpMem(addr: POINTER; len, offset: WORD);
 VAR i: WORD;
 s1, s2: STRING;
BEGIN
 s1 := ''; s2 := '';
 FOR i := 0 TO len-1 DO BEGIN
  s1 := s1 + HexStr(BPTR(addr)^,2) + ' ';
  IF (i AND $0F) = $07 THEN s1 := s1 + '. ';
  IF BPTR(addr)^ IN [$20..$7E,$80..$FE] THEN
   s2 := s2 + Chr(BPTR(addr)^)
  ELSE
   s2 := s2 + '.';
  IF (i AND $0F) = $0F THEN BEGIN
   WriteLn(HexStr(offset, 4),' - ',s1,'  ',s2);
   s1 := ''; s2 := ''; Inc(offset, $10);
  END;
  Inc(BPTR(addr));
 END; (* for *)
 IF len AND $0F <> 0 THEN
  WriteLn(HexStr(offset, 4),' - ',s1,'':50-Length(s1),'  ',s2);
END; (* DumpMem *)

PROCEDURE DumpVar(VAR vari; len, offset: WORD);
BEGIN
 DumpMem(@vari,len,offset);
END; (* DumpVar *)

END. (* Dump *)
